## javax.servlet
Interface ServletResponse

All Known Subinterfaces:
  HttpServletResponse

All Known Implementing Classes:
  ServletResponseWrapper

public interface ServletResponse

Defines an object to assist a servlet in sending a response to the client. The servlet container creates a `ServletResponse` object and passes it as an argument to the servlet's `service` method.

To send binary data in a MIME body response, use the `ServletOutputStream` returned by `getOutputStream()`. To send character data, use the `PrintWriter` object returned by `getWriter()`. To mix binary and text data, for example, to create a multipart response, use a `ServletOutputStream` and manage the character sections manually.

The charset for the MIME body response can be specified with `setContentType(java.lang.String)`. For example, "text/html; charset=Shift_JIS". The charset can alternately be set using `setLocale(java.util.Locale)`. If no charset is specified, ISO-8859-1 will be used. The `setContentType` or `setLocale` method must be called before `getWriter` for the charset to affect the construction of the writer.

See the Internet RFCs such as RFC 2045 for more information on MIME. Protocols such as SMTP and HTTP define profiles of MIME, and those standards are still evolving.

Version:
  $Version$
Author:
  Various
See Also:
  `ServletOutputStream`

Method Summary
`void` `flushBuffer()` Forces any content in the buffer to be written to the client.
`int` `getBufferSize()` Returns the actual buffer size used for the response.
`java.lang.String` `getCharacterEncoding()` Returns the name of the charset used for the MIME body sent in this response.
`java.util.Locale` `getLocale()` Returns the locale assigned to the response.
`ServletOutputStream` `getOutputStream()` Returns a `ServletOutputStream` suitable for writing binary data in the response.
`java.io.PrintWriter` `getWriter()` Returns a `PrintWriter` object that can send character text to the client.
`boolean` `isCommitted()` Returns a boolean indicating if the response has been committed.
`void` `reset()` Clears any data that exists in the buffer as well as the status code and headers.
`void` `resetBuffer()` Clears the content of the underlying buffer in the response without clearing headers or status code.
`void` `setBufferSize(int size)` Sets the preferred buffer size for the body of the response.
`void` `setContentLength(int len)` Sets the length of the content body in the response In HTTP servlets, this method sets the HTTP Content-Length header.
`void` `setContentType(java.lang.String type)` Sets the content type of the response being sent to the client.
`void` `setLocale(java.util.Locale loc)` Sets the locale of the response, setting the headers (including the Content-Type's charset) as appropriate.

Method Detail

### getCharacterEncoding

    public java.lang.String getCharacterEncoding()

  Returns the name of the charset used for the MIME body sent in this response.

  If no charset has been assigned, it is implicitly set to `ISO-8859-1` (`Latin-1`).

  See RFC 2047 (http://ds.internic.net/rfc/rfc2045.txt) for more information about character encoding and MIME.

  Returns:
    a `String` specifying the name of the charset, for example, `ISO-8859-1`

### getOutputStream

    public ServletOutputStream getOutputStream()
                                        throws java.io.IOException

  Returns a `ServletOutputStream` suitable for writing binary data in the response. The servlet container does not encode the binary data.

  Calling flush() on the ServletOutputStream commits the response. Either this method or `getWriter()` may be called to write the body, not both.

  Returns:
    a `ServletOutputStream` for writing binary data
  Throws:
    `java.lang.IllegalStateException` - if the `getWriter` method has been called on this response
    `java.io.IOException` - if an input or output exception occurred
  See Also:
    `getWriter()`

### getWriter

    public java.io.PrintWriter getWriter()
                                  throws java.io.IOException

  Returns a `PrintWriter` object that can send character text to the client. The character encoding used is the one specified in the `charset=` property of the `setContentType(java.lang.String)` method, which must be called before calling this method for the charset to take effect.

  If necessary, the MIME type of the response is modified to reflect the character encoding used.

  Calling flush() on the PrintWriter commits the response.

  Either this method or `getOutputStream()` may be called to write the body, not both.

  Returns:
    a `PrintWriter` object that can return character data to the client
  Throws:
    `java.io.UnsupportedEncodingException` - if the charset specified in `setContentType` cannot be used
    `java.lang.IllegalStateException` - if the `getOutputStream` method has already been called for this response object
    `java.io.IOException` - if an input or output exception occurred
  See Also:
    `getOutputStream()`, `setContentType(java.lang.String)`

### setContentLength

    public void setContentLength(int len)

  Sets the length of the content body in the response In HTTP servlets, this method sets the HTTP Content-Length header.
  Parameters:
    `len` - an integer specifying the length of the content being returned to the client; sets the Content-Length header

### setContentType

    public void setContentType(java.lang.String type)

  Sets the content type of the response being sent to the client. The content type may include the type of character encoding used, for example, `text/html; charset=ISO-8859-4`.

  If obtaining a `PrintWriter`, this method should be called first.

  Parameters:
    `type` - a `String` specifying the MIME type of the content
  See Also:
    `getOutputStream()`, `getWriter()`

### setBufferSize

    public void setBufferSize(int size)

  Sets the preferred buffer size for the body of the response. The servlet container will use a buffer at least as large as the size requested. The actual buffer size used can be found using `getBufferSize`.

  A larger buffer allows more content to be written before anything is actually sent, thus providing the servlet with more time to set appropriate status codes and headers. A smaller buffer decreases server memory load and allows the client to start receiving data more quickly.

  This method must be called before any response body content is written; if content has been written, this method throws an `IllegalStateException`.

  Parameters:
    `size` - the preferred buffer size
  Throws:
    `java.lang.IllegalStateException` - if this method is called after content has been written
  See Also:
    `getBufferSize()`, `flushBuffer()`, `isCommitted()`, `reset()`

### getBufferSize

    public int getBufferSize()

  Returns the actual buffer size used for the response. If no buffering is used, this method returns 0.
  Returns:
    the actual buffer size used
  See Also:
    `setBufferSize(int)`, `flushBuffer()`, `isCommitted()`, `reset()`

### flushBuffer

    public void flushBuffer()
                     throws java.io.IOException

  Forces any content in the buffer to be written to the client. A call to this method automatically commits the response, meaning the status code and headers will be written.
  See Also:
    `setBufferSize(int)`, `getBufferSize()`, `isCommitted()`, `reset()`

### resetBuffer

    public void resetBuffer()

  Clears the content of the underlying buffer in the response without clearing headers or status code. If the response has been committed, this method throws an `IllegalStateException`.
  Since:
    2.3
  See Also:
    `setBufferSize(int)`, `getBufferSize()`, `isCommitted()`, `reset()`

### isCommitted

    public boolean isCommitted()

  Returns a boolean indicating if the response has been committed. A commited response has already had its status code and headers written.
  Returns:
    a boolean indicating if the response has been committed
  See Also:
    `setBufferSize(int)`, `getBufferSize()`, `flushBuffer()`, `reset()`

### reset

    public void reset()

  Clears any data that exists in the buffer as well as the status code and headers. If the response has been committed, this method throws an `IllegalStateException`.
  Throws:
    `java.lang.IllegalStateException` - if the response has already been committed
  See Also:
    `setBufferSize(int)`, `getBufferSize()`, `flushBuffer()`, `isCommitted()`

### setLocale

    public void setLocale(java.util.Locale loc)

  Sets the locale of the response, setting the headers (including the Content-Type's charset) as appropriate. This method should be called before a call to `getWriter()`. By default, the response locale is the default locale for the server.
  Parameters:
    `loc` - the locale of the response
  See Also:
    `getLocale()`

### getLocale

    public java.util.Locale getLocale()

  Returns the locale assigned to the response.
  See Also:
    `setLocale(java.util.Locale)`

Copyright © 1999-2001 The Apache Software Foundation. All Rights Reserved.